function [battANALOG,ATTIVA,FIG,FIG_ENG] = report_2DCrL(r2DCrL,m,Nodo2DCrackLink,toolrif,...
    unitrif,contunit,datarif,Font_caption,Font_tools,battANALOG,ATTIVA,siteID,DT,DT_ENG,...
    FIG,FIG_ENG,br,status,activeEN,conn,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'report_2DCrL function started';
fprintf(fileID,fmt,text);

import mlreportgen.dom.*
import mlreportgen.report.*

% Make sure DOM is compilable
makeDOMCompilable()

if status(m,1) == 1
    if ATTIVA == 1
        testo = Paragraph('GMUX non ancora installato o canale inattivo.');
        add(DT,testo);
        ATTIVA = 0;
        if activeEN == 1
            testo = Paragraph('GMUX not installed or inactive.');
            add(DT_ENG,testo);
        end
    end
elseif status(m,1) == 3
    if ATTIVA == 1
        testo = Paragraph(['Monitoraggio completato. Invitiamo a visitare la '...
            'piattaforma web per la visione dei dati storici.']);
        ATTIVA = 0;
        add(DT,testo);
        if activeEN == 1
            testo = Paragraph(['Monitoring completed. Please log into the web-based platform '...
                'to access the complete dataset.']);
            add(DT_ENG,testo);
        end
    end
else
    Cr3D = Section();
    sez2DCrack = Heading3('2D Crack Link');
    sez2DCrack.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
    Cr3D.Title = sez2DCrack;
    if battANALOG == 0
        comando = ['select Date, Time, UnitName, ToolNameID, BatLevel, Temperature from RawDataView where Date >= ''' ...
            datarif ''' and UnitName = ''' char(unitrif) ''' and ToolNameID = '''...
            char(toolrif) ''' and NodeNum = 1 '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        BatTemp = curs.Data;
        [~,cc] = size(BatTemp);
        
        if cc ~= 1 %ci sono dati riferiti all'ultimo mese/periodo di interesse
            DataPlot = [BatTemp(:,1) BatTemp(:,2)];
            % sistemo date, batteria e temperatura
            [rD,~] = size(DataPlot);
            T = [cell2mat(DataPlot(:,1)) repmat(' ', [rD,1]) cell2mat(DataPlot(:,2))];
            Date = datenum(T);
            Batteria = cell2mat(BatTemp(:,5));
            Temperatura = cell2mat(BatTemp(:,6));
            
            % testo introduttivo
            testoB1 = Paragraph(['I valori di tensione di alimentazione del GMUX durante il periodo '...
                'di monitoraggio sono riportati di seguito. Il corretto funzionamento del sistema '...
                char(232) ' assicurato per una carica superiore a 12 V. L''ultimo dato disponibile ' char(232) ' pari '...
                'a ' num2str(Batteria(end,1)) ' V.']);
            testoB2 = Paragraph(['Il GMUX integra al proprio interno un termometro '...
                'per monitorate la temperatura di esercizio ed identificare eventuali '...
                'anomalie. I dati di temperatura registrati sono riportati di seguito.']);
            testoB1.HAlign = 'justify';
            testoB2.HAlign = 'justify';
            
            % grafico batteria
            figure(19)
            plot(Date,Batteria);
            hold on
            title('Batteria e Temperatura del GMUX');
            xlabel('Data [gg/mm/aaaa]');
            ylabel('Livello di Batteria [V]');
            ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
            
            yyaxis right
            GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
            ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
            ylabel(['Temperatura [' char(176) 'C]']);
            set(gca,'YColor','k');
            str(1,1) = cellstr('Batteria');
            str(2,1) = cellstr('Temperatura');
            legend(str,'Location','northwest');
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            xlim([Date(1)-1 Date(end)+1]);
            
            TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX.png'));
            saveas(GMUX,TempName);
            ChartGMUX = Image(TempName);
            ChartGMUX.Style = {Height('8cm'),HAlign('center')};
            if Batteria(end,1) >= 12.5
                TempName = char(strcat('B_13.jpg'));
            elseif Batteria(end,1) >= 12
                TempName = char(strcat('B_12.jpg'));
            elseif Batteria(end,1) >= 11.3
                TempName = char(strcat('B_115.jpg'));
            elseif Batteria(end,1) >= 10.5
                TempName = char(strcat('B_11.jpg'));
            else
                TempName = char(strcat('B_10.jpg'));
            end
            Batt = Image(TempName);
            Batt.Style = {Height('4cm'),HAlign('center')};
            
            lot = Table({ChartGMUX, Batt});
            lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
            lot.Style = {ResizeToFitContents(false),Width("100%")};
            grps(1) = TableColSpecGroup;
            grps(1).Span = 2;
            specs(1) = TableColSpec;
            specs(1).Span = 1;
            specs(1).Style = {Width("80%")};
            specs(2) = TableColSpec;
            specs(2).Span = 1;
            specs(2).Style = {Width("20%")};
            grps(1).ColSpecs = specs;
            lot.ColSpecGroups = grps;
            
            lot_cap = Paragraph(['Fig. ' num2str(FIG) ' - Livello di carica della batteria e temperatura del '...
                'GMUX durante il periodo di riferimento']);
            FIG = FIG+1;
            lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            Batt = Section();
            sezBATT = Heading3('GMUX - Batteria e Temperatura');
            sezBATT.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
            Batt.Title = sezBATT;
            add(DT,sezBATT);
            add(DT,testoB1);
            add(DT,testoB2);
            add(DT,lot);
            add(DT,lot_cap);
            add(DT,br);
            close(figure(19));
            
            %--ENG---
            if activeEN == 1
                Cr2D_ENG = Section();
                sez2DCrL_ENG = Heading3('2D Crack Link');
                sez2DCrL_ENG.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                Cr2D_ENG.Title = sez2DCrL_ENG;
                
                testoB1 = Paragraph(['The following chart reports the GMUX battery level trend recorded '...
                    'during the reference time period. '...
                    'The correct functioning of the data acquisition system is guaranteed for a '...
                    'minimum level of 12 V. The last available data is equal to ' num2str(Batteria(end,1)) ' V.']);
                testoB2 = Paragraph(['GMUX equips also a thermometer that allows the monitoring '...
                    'of the working temperature and the identification of eventual malfunctioning. The same '...
                    'chart displays also temperature data recorded by the multiplexer.']);
                testoB1.HAlign = 'justify';
                testoB2.HAlign = 'justify';
                
                % grafico batteria
                figure(19)
                plot(Date,Batteria);
                hold on
                title('GMUX battery level and temperature');
                xlabel('Date [dd/mm/yyyy]');
                ylabel('Battery Level [V]');
                ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
                
                yyaxis right
                GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
                ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
                ylabel(['Temperature [' char(176) 'C]']);
                set(gca,'YColor','k');
                str(1,1) = cellstr('Battery');
                str(2,1) = cellstr('Temperature');
                legend(str,'Location','northwest');
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                xlim([Date(1)-1 Date(end)+1]);
                
                TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX_ENG.png'));
                saveas(GMUX,TempName);
                ChartGMUX = Image(TempName);
                ChartGMUX.Style = {Height('8cm'),HAlign('center')};
                Batt = Image(TempNameB);
                Batt.Style = {Height('4cm'),HAlign('center')};
                
                lot = Table({ChartGMUX, Batt});
                lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
                lot.Style = {ResizeToFitContents(false),Width("100%")};
                grps(1) = TableColSpecGroup;
                grps(1).Span = 2;
                specs(1) = TableColSpec;
                specs(1).Span = 1;
                specs(1).Style = {Width("80%")};
                specs(2) = TableColSpec;
                specs(2).Span = 1;
                specs(2).Style = {Width("20%")};
                grps(1).ColSpecs = specs;
                lot.ColSpecGroups = grps;
                
                lot_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Battery level and temperature recorded '...
                    'by the GMUX during the reference time period']);
                FIG_ENG = FIG_ENG+1;
                lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                Batt_ENG = Section();
                sezBATT_ENG = Heading3('GMUX - Battery and temperature');
                sezBATT_ENG.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
                Batt_ENG.Title = sezBATT_ENG;
                add(DT_ENG,sezBATT_ENG);
                add(DT_ENG,testoB1);
                add(DT_ENG,testoB2);
                add(DT_ENG,lot);
                add(DT_ENG,lot_cap);
                add(DT_ENG,br);
                close(figure(19));
            end
            battANALOG = 1;
        end
    end
    add(DT,sez2DCrack);
    if activeEN == 1
        add(DT_ENG,sez2DCrL_ENG);
    end
    for cr = 1:r2DCrL(m,1)
        NodeNum = num2str(Nodo2DCrackLink(cr,m));
        comando = ['select EventDate, EventTime, XShift, YShift from ElabDataView where EventDate >= ''' ...
            datarif ''' and  ToolNameID = ''' char(toolrif) ''' and UnitName = ''' char(unitrif) ...
            ''' and NodeNum = ''' NodeNum ''' '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        Dati = curs.Data;
        % Modifico il formato di data e ora
        [rD,rC] = size(Dati);
        if rC ~= 1
            T = [cell2mat(Dati(:,1)) repmat(' ', [rD,1]) cell2mat(Dati(:,2))];
            Date = datenum(T); % Data
            X = cell2mat(Dati(:,3)); % Fessura
            Y = cell2mat(Dati(:,4)); % Fessura
            sX = X-X(1);
            sY = Y-Y(1);
            
            % grafico deformazioni NELL'ULTIMO MESE
            figure(5);
            plot(Date,sX);
            hold on
            apertura = plot(Date,sY);
            title(['Apertura/chiusura del fessurimetro numero ' NodeNum]);
            xlabel('Data [gg/mm/aaaa]');
            ylabel('Deformazione [mm]');
            controlX = abs(max(sX)-min(sX));
            controlY = abs(max(sY)-min(sY));
            controlXY = [controlX; controlY];
            control = max(controlXY);
            if control < 0.5 % mm
                ylim([-0.5 0.5]);
            end
            xlim([Date(1)-1 Date(end)+1]);
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(15);
            grid on
            grid minor
            hold off
            str(1,1) = cellstr('X');
            str(2,1) = cellstr('Y');
            MX(1) = max(sX(1:10));
            MX(2) = max(sY(1:10));
            MN(1) = min(sX(1:10));
            MN(2) = min(sY(1:10));
            VAR(1) = max(MX);
            VAR(2) = min(MN);
            MAX = max(abs(VAR));
            IN = find(abs(VAR)==MAX);
            if IN == 1 % Legenda sotto
                legend(str,'Location','southwest');
            else
                legend(str,'Location','northwest');
            end
            
            TempName = char(strcat('Report',siteID,'-', char(toolrif),'-2DCrack', NodeNum, '.png'));
            saveas(apertura,TempName);
            Chart2DCrL = Image(TempName);
            Chart2DCrL.Style = {Height('7.5cm'),HAlign('center')};
            Chart2DCrL_cap = Paragraph(['Fig. ' num2str(FIG) ' - Andamento '...
                'dell''apertura (valori crescenti) o chiusura (valori decrescenti) '...
                'registrata lungo i due assi strumentali del fessurimetro, nodo numero ' NodeNum ...
                ', durante il periodo temporale di riferimento']);
            FIG = FIG+1;
            Chart2DCrL_cap.Style = {HAlign('justify'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            
            testo = Paragraph(['Nei grafici seguenti sono rappresentati i dati relativi '...
                'alla deformazione differenziale registrata lungo i due assi strumentali '...
                'dai fessurimetri bidimensionali che compongono l''Analog Array.']);
            testo2 = Paragraph(['Durante il periodo temporale di riferimento, il nodo numero ' NodeNum ' ha '...
                'registrato i seguenti valori di apertura assoluta dello strumento: ']);
            testoX = Paragraph(['- Asse X - Valore Massimo assoluto: ' num2str(round(max(X),2), '%0.2f') ...
                ' mm, valore minimo: ' num2str(round(min(X),2), '%0.2f') ' mm, variazione: ' ...
                num2str(round(max(X),2)-round(min(X),2),'%0.2f') ' mm; ']);
            testoY = Paragraph(['- Asse Y - Valore Massimo assoluto: ' num2str(round(max(Y),2), '%0.2f') ...
                ' mm, valore minimo: ' num2str(round(min(Y),2), '%0.2f') ' mm, variazione: ' ...
                num2str(round(max(Y),2)-round(min(Y),2),'%0.2f') ' mm; ']);
            spazio = Paragraph('');
            
            testo.HAlign = 'justify';
            testo2.HAlign = 'justify';
            if cr == 1
                add(DT,testo);
            end
            add(DT,testo2);
            add(DT,testoX);
            add(DT,testoY);
            add(DT,Chart2DCrL);
            add(DT,Chart2DCrL_cap);
            add(DT,spazio);
            if cr == r2DCrL(m,1)
                add(DT,br);
            end
            close(figure(19));
            close(figure(5));
            
            %---ENG---
            if activeEN == 1
                % grafico deformazioni NELL'ULTIMO MESE
                figure(15);
                plot(Date,sX);
                hold on
                plot(Date,sY);
                apertura = plot(Date,sZ);
                title(['Crack meter deformation - node ' NodeNum]);
                xlabel('Date [dd/mm/yyyy]');
                ylabel('Deformation [mm]');
                controlX = abs(max(sX)-min(sX));
                controlY = abs(max(sY)-min(sY));
                controlZ = abs(max(sZ)-min(sZ));
                controlXY = [controlX; controlY; controlZ];
                control = max(controlXY);
                if control < 0.5 % mm
                    ylim([-0.5 0.5]);
                end
                xlim([Date(1)-1 Date(end)+1]);
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(15);
                grid on
                grid minor
                hold off
                str(1,1) = cellstr('X');
                str(2,1) = cellstr('Y');
                MX(1) = max(sX(1:10));
                MX(2) = max(sY(1:10));
                MN(1) = min(sX(1:10));
                MN(2) = min(sY(1:10));
                VAR(1) = max(MX);
                VAR(2) = min(MN);
                MAX = max(abs(VAR));
                IN = find(abs(VAR)==MAX);
                if IN == 1 % Legenda sotto
                    legend(str,'Location','southwest');
                else
                    legend(str,'Location','northwest');
                end
                
                TempName = char(strcat('Report',siteID,'-', char(toolrif),'-2DCrack', NodeNum, '_ENG.png'));
                saveas(apertura,TempName);
                Chart3DCrL_ENG = Image(TempName);
                Chart3DCrL_ENG.Style = {Height('7.5cm'),HAlign('center')};
                Chart3DCrL_ENG_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - 2D crack '...
                    'opening measured along the two instrumental axes by node ' ...
                    NodeNum ' during the reference time period']);
                FIG_ENG = FIG_ENG+1;
                Chart3DCrL_ENG_cap.Style = {HAlign('justify'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                
                testo = Paragraph(['The following graphs present differential deformation data '...
                    'recorded along the two instrumental axes by 2D crack meters '...
                    'integrated in the Analog Array.']);
                testo2 = Paragraph(['During the reference time period, node ' NodeNum ...
                    ' recorded the following values of crack opening: ']);
                testoX = Paragraph(['- X axis - Maximum absolute value: ' num2str(round(max(X),2), '%0.2f') ...
                    ' mm, minimum value: ' num2str(round(min(X),2), '%0.2f') ' mm, variation: ' ...
                    num2str(round(max(X),2)-round(min(X),2),'%0.2f') ' mm; ']);
                testoY = Paragraph(['- Y axis - Maximum absolute value: ' num2str(round(max(Y),2), '%0.2f') ...
                    ' mm, minimum value: ' num2str(round(min(Y),2), '%0.2f') ' mm, variation: ' ...
                    num2str(round(max(Y),2)-round(min(Y),2),'%0.2f') ' mm; ']);;
                spazio = Paragraph('');
                
                testo.HAlign = 'justify';
                testo2.HAlign = 'justify';
                if cr == 1
                    add(DT_ENG,testo);
                end
                add(DT_ENG,testo2);
                add(DT_ENG,testoX);
                add(DT_ENG,testoY);
                add(DT_ENG,Chart3DCrL_ENG);
                add(DT_ENG,Chart3DCrL_ENG_cap);
                add(DT_ENG,spazio);
                if cr == r2DCrL(m,1)
                    add(DT_ENG,br);
                end
                close(figure(15));
            end
        else
            if ATTIVA == 1
                ATTIVA = 0;
                Cr2D = Section();
                sez2DCrack = Heading3('2D Crack Link');
                sez2DCrack.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                Cr2D.Title = sez2DCrack;
                add(DT,sez2DCrack);
                testo = Paragraph('Non sono presenti dati relativi al periodo temporale considerato.');
                add(DT,testo);
                add(DT,br);
                if activeEN == 1
                    Cr2D_ENG = Section();
                    sez2DCrL_ENG = Heading3('2D Crack Link');
                    sez2DCrL_ENG.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                    Cr2D_ENG.Title = sez2DCrL_ENG;
                    add(DT_ENG,sez2DCrL_ENG);
                    testo = Paragraph('No data available for the reference time period.');
                    add(DT_ENG,testo);
                    add(DT_ENG,br);
                end
            end
        end
    end
end

text = 'report_2DCrL function executed correctly';
fprintf(fileID,fmt,text);
fclose(fileID);

end